package descriptor;
import java.lang.management.ManagementFactory;
import javax.management.Descriptor;
import javax.management.MBeanAttributeInfo;
import javax.management.MBeanInfo;
import javax.management.MBeanServer;
import javax.management.ObjectName;

public class MXBeanDemo {
    public static void main(String[] args) throws Exception {
        // Create an instance of CarMXBean
        CarImpl mxBean = new CarImpl();
        // Create ObjectName for mxBean
        ObjectName objectName = new ObjectName(
                "mymxbean:name=with_descriptor");

        // Get MBeanServer from ManagementFactory
        MBeanServer server = ManagementFactory.
                getPlatformMBeanServer();
        
        // Register MXBean with MBeanServer
        server.registerMBean(mxBean, objectName);

        // Get MBeanInfo
        MBeanInfo mbeanInfo = server.getMBeanInfo(objectName);

        // Get all attributes
        for (MBeanAttributeInfo attributeInfo : 
            mbeanInfo.getAttributes()) {
            
            String attributeName = attributeInfo.getName();
            if (attributeName.equalsIgnoreCase("numberOfDoors")) {
                System.out.println("Attribute " + attributeName);
                Descriptor descriptor = attributeInfo.getDescriptor();
                System.out.println("Note = " +
                        descriptor.getFieldValue("note"));
                System.out.println("minValue = " +
                        descriptor.getFieldValue("minValue"));
                System.out.println("maxValue = " +
                        descriptor.getFieldValue("maxValue"));
            }
        }
    }
}